-------------------------------------------------------------------------------
-- Blizzard Finnegan
-- 2 Function 8-bit Calculator test bench
-------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity two_func_calc_tb is
end two_func_calc_tb;

architecture arch of two_func_calc_tb is

component top is
  port(
    clk             : in  std_logic;
    reset           : in  std_logic;
    input_switches  : in  std_logic_vector(7 downto 0);
    state_cycle     : in  std_logic;
    state_indicator : out std_logic_vector(3 downto 0);
    hundreds_disp   : out std_logic_vector(6 downto 0);
    tens_disp       : out std_logic_vector(6 downto 0);
    ones_disp       : out std_logic_vector(6 downto 0)
  );
end component; 

signal clock : std_logic := '0';
signal reset : std_logic := '1';
signal state_cycle : std_logic := '0';
signal input_switches : std_logic_vector(7 downto 0);

begin

clock_toggle: process
begin
  clock <= not clock;
  wait for 5 ns;
end process;

async_reset: process
begin
  wait for 20 ns;
  reset <= '0';
end process;

stimuli: process
begin
  -- a = 5
  input_switches <= std_logic_vector(to_unsigned(5,input_switches'length));
  wait for 150 ns;
  state_cycle <= '1';
  wait for 20 ns;
  state_cycle <= '0';

  -- b = 2
  input_switches <= std_logic_vector(to_unsigned(2,input_switches'length));
  wait for 80 ns;
  state_cycle <= '1';
  wait for 20 ns;
  state_cycle <= '0';

  -- Show outputs
  for i in 0 to 1 loop
    wait for 80 ns;
    state_cycle <= '1';
    wait for 20 ns;
    state_cycle <= '0';
  end loop;

  -- a = 2
  input_switches <= std_logic_vector(to_unsigned(2,input_switches'length));
  wait for 80 ns;
  state_cycle <= '1';
  wait for 20 ns;
  state_cycle <= '0';

  -- b = 5
  input_switches <= std_logic_vector(to_unsigned(5,input_switches'length));
  wait for 80 ns;
  state_cycle <= '1';
  wait for 20 ns;
  state_cycle <= '0';

  -- Show outputs
  for i in 0 to 1 loop
    wait for 80 ns;
    state_cycle <= '1';
    wait for 20 ns;
    state_cycle <= '0';
  end loop;

  -- a = 200
  input_switches <= std_logic_vector(to_unsigned(200,input_switches'length));
  wait for 80 ns;
  state_cycle <= '1';
  wait for 20 ns;
  state_cycle <= '0';

  -- b = 100
  input_switches <= std_logic_vector(to_unsigned(100,input_switches'length));
  wait for 80 ns;
  state_cycle <= '1';
  wait for 20 ns;
  state_cycle <= '0';

  -- Show outputs
  for i in 0 to 1 loop
    wait for 80 ns;
    state_cycle <= '1';
    wait for 20 ns;
    state_cycle <= '0';
  end loop;

  -- a = 100
  input_switches <= std_logic_vector(to_unsigned(100,input_switches'length));
  wait for 80 ns;
  state_cycle <= '1';
  wait for 20 ns;
  state_cycle <= '0';

  -- b = 200
  input_switches <= std_logic_vector(to_unsigned(200,input_switches'length));
  wait for 80 ns;
  state_cycle <= '1';
  wait for 20 ns;
  state_cycle <= '0';

  -- Show outputs
  for i in 0 to 1 loop
    wait for 80 ns;
    state_cycle <= '1';
    wait for 20 ns;
    state_cycle <= '0';
  end loop;
end process;

uut: top  
  port map(
    clk => clock,
    reset => reset,
    state_cycle => state_cycle,
    input_switches => input_switches,
    state_indicator => open,
    hundreds_disp => open,
    tens_disp => open,
    ones_disp => open
  );
end arch;
