
-------------------------------------------------------------------------------
-- Blizzard Finnegan
-- S/R flip-flop
-------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity double_buffer is
  generic (
    bits : integer := 4
  );
  port(
    d     : in  std_logic_vector(bits - 1 downto 0);
    clk   : in  std_logic;
    reset : in  std_logic;
    q     : out std_logic_vector(bits - 1 downto 0)
  );
end entity double_buffer;

architecture arch of double_buffer is

signal d_buf : std_logic_vector(bits - 1 downto 0);

begin
process(clk, reset)
begin
  if(reset = '1') then
    q <= (others => '0');
    d_buf <= (others => '0');
  elsif (clk'event and clk = '1') then
    d_buf <= d;
    q <= d_buf;
  end if;
end process;
end arch;
